Program Physic_model;
Uses Graph, Crt, Dos;
 const
      Per = 0.004;      {Period}
      dt  = 0.0001;     {Small time}
      n_st_body  = 50;  {Static_bodies}
      n_dn_body  = 10;  {Dynamic_bodies}

 type dynamic_body = record   {Information about Dynamic_Body}
      x,y,xl,yl     : real;    {Important variables}
      speedx,speedy : real;
      ax,ay,m       : real;
      image         : pointer; {Not Important variables}
      color,fcolor,
      fstyle,r      : integer;
 end;
 type static_line  = record
      x1,y1,x2,y2   : integer;
      color         : byte;
      dE            : single;
 end;
 type static_curve = record
      x,y,rad       : integer;
      BegA,EndA     : integer;
      color         : byte;
      dE            : single;
 end;
 type mouse_info   = record
      x,y,xl,yl     : integer;
      l_b,r_b       : boolean;
 end;
 type st_ln_mas  = array [1..n_st_body] of static_line;
 type st_cr_mas  = array [1..n_st_body] of static_curve;
 type dn_bd_mas  = array [1..n_dn_body] of dynamic_body;

 var
      gd,gm,i,Error: integer;
      n_dn_b       : integer;
      n_st_b       : integer;
      n_st_c       : integer;
      line_mas     : st_ln_mas;
      curve_mas    : st_cr_mas;
      dynamic_mas  : dn_bd_mas;
      mouse        : mouse_info;
      time         : real;
      num          : char;
      exit         : boolean;
      dn_body_num  : integer;

procedure Strelka(x,y:integer);
begin
  setwritemode(1);
  setcolor(yellow);
  line(x-5,y,x+6,y);
  line(x-5,y+1,x+6,y+1);
  line(x,y-5,x,y+6);
  line(x+1,y-5,x+1,y+6);
end;

procedure Move_Mouse(var x,y,xl,yl:integer);
begin
  if (x<>xl)or(y<>yl) then begin
   strelka(xl,yl);
   strelka(x,y);
   xl:=x;
   yl:=y;
  end;
end;

procedure State_Mouse(var l_b:boolean; var x,y:integer);
  var regs : Registers;
begin
   regs.AX:=3;
   intr($33, regs);
   x:=regs.CX;
   y:=regs.DX;
   l_b:=false;
   l_b:=(regs.BX and 1) <> 0;
end;

procedure Check_Mouse(var m:mouse_info);
begin
   State_Mouse(m.l_b,m.x,m.y);
   Move_Mouse(m.x,m.y,m.xl,m.yl);
end;

procedure Preparation(var dnbm:dn_bd_mas; var stlm:st_ln_mas;
                      var stcm:st_cr_mas; var dn_b,st_l,st_c:integer);
  var i    : integer;
      f    : text;
      head : string;
begin
   dn_b:=0; st_l:=0; st_c:=0;
   Assign(f,'MAP_NEW'+num+'.TXT');
    {$I-}
   reset(f);
    {$I+}
  if IOResult <> 0 then begin
   CloseGraph;
   writeln('Error: File not found. Press "Enter" to Exit.');
   readln;
   halt;
  end;
  repeat
   readln(f,head);
   if head='dn_body' then begin
      dn_b:=dn_b+1;
      readln(f,dnbm[dn_b].x,dnbm[dn_b].y);
      readln(f,dnbm[dn_b].speedx,dnbm[dn_b].speedy);
      readln(f,dnbm[dn_b].ax,dnbm[dn_b].ay);
      readln(f,dnbm[dn_b].r,dnbm[dn_b].m);
      readln(f,dnbm[dn_b].color,dnbm[dn_b].fstyle,dnbm[dn_b].fcolor);
      readln(f,dnbm[dn_b].xl,dnbm[dn_b].yl);
   end;
   if head='st_line' then begin
      st_l:=st_l+1;
      readln(f,stlm[st_l].x1,stlm[st_l].y1);
      readln(f,stlm[st_l].x2,stlm[st_l].y2);
      readln(f,stlm[st_l].color,stlm[st_l].dE);
   end;
   if head='st_curve' then begin
      st_c:=st_c+1;
      readln(f,stcm[st_c].x,stcm[st_c].y,stcm[st_c].rad);
      readln(f,stcm[st_c].BegA,stcm[st_c].EndA);
      readln(f,stcm[st_c].color,stcm[st_c].dE);
   end;
  until head='end';
   close(f);
  for i:=1 to dn_b do GetMem(dnbm[i].image,ImageSize(1,1,1+2*dnbm[i].r,1+2*dnbm[i].r));
  for i:=1 to dn_b do begin
   setcolor(dnbm[i].color);
   circle(dnbm[i].r+1,dnbm[i].r+1,dnbm[i].r-1);
   setfillstyle(dnbm[i].fstyle,dnbm[i].fcolor);
   floodfill(dnbm[i].r+1,dnbm[i].r+1,dnbm[i].color);
   GetImage(1,1,1+2*dnbm[i].r,1+2*dnbm[i].r,dnbm[i].image^);
   setfillstyle(1,Black);
   bar(1,1,1+2*dnbm[i].r,1+2*dnbm[i].r);
  end;
end;

procedure Draw_Dynamic_Body(b:dynamic_body; del:boolean);
begin
  if (round(b.xl)<>round(b.x))or(round(b.yl)<>round(b.y)) then begin
   if del then PutImage(round(b.xl-b.r),round(b.yl-b.r),b.image^,XorPut);
   PutImage(round(b.x-b.r),round(b.y-b.r),b.image^,XorPut);
  end;
end;

procedure Draw_Static_Body(b:static_line);
begin
  setcolor(b.color);
  line(b.x1,b.y1,b.x2,b.y2);
end;

procedure Draw_Static_Curve(c:static_curve);
begin
  setcolor(c.color);
  Arc(c.x,c.y,360-c.EndA,360-c.BegA,c.rad);
end;

procedure Draw_Map;
  var i : integer;
begin
   SetBkColor(7);
   Strelka(mouse.x,mouse.y);
  for i:=1 to n_st_b do begin
   Draw_Static_Body(line_mas[i]);
  end;
  for i:=1 to n_st_c do begin
   Draw_Static_Curve(curve_mas[i]);
  end;
  for i:=1 to n_dn_b do Draw_Dynamic_Body(dynamic_mas[i],false);
end;

function Distance(x1,y1,x2,y2:real) : real;
begin
  Distance:=sqrt(sqr(x1-x2)+sqr(y1-y2));
end;

function Touch_Line(dnb:dynamic_body; stb:static_line; var xl,yl:real) : boolean;
  var x1,y1,x2,y2 : integer;
      k,x,y       : real;
begin
   Touch_Line:=False;
  if stb.x1>stb.x2 then begin
   x1:=stb.x2; x2:=stb.x1;
   y1:=stb.y2; y2:=stb.y1
  end else if stb.x1<stb.x2 then begin
   x1:=stb.x1; x2:=stb.x2;
   y1:=stb.y1; y2:=stb.y2
  end else if stb.y1>stb.y2 then begin
   y1:=stb.y2; y2:=stb.y1;
   x1:=stb.x2; x2:=stb.x1;
  end else if stb.y1<stb.y2 then begin
   y1:=stb.y1; y2:=stb.y2;
   x1:=stb.x1; x2:=stb.x2;
  end;
   x:=0; y:=0;
  if x1<>x2 then begin
    k:=(y2-y1)/(x2-x1);
    x:=x1+(dnb.x-x1+(dnb.y-y1)*k)/(1+sqr(k));
    y:=y1+k*(dnb.x-x1+(dnb.y-y1)*k)/(1+sqr(k));
   if Distance(x,y,dnb.x,dnb.y)<=dnb.r then begin
    if (x>=x1)and(x<=x2) then begin
     xl:=x; yl:=y; Touch_Line:=True end
    else
    if Distance(x1,y1,dnb.x,dnb.y)<=dnb.r then begin
     xl:=x1; yl:=y1; Touch_Line:=True end
    else
    if Distance(x2,y2,dnb.x,dnb.y)<=dnb.r then begin
     xl:=x2; yl:=y2; Touch_Line:=True end;
   end;
  end
  else begin
    x:=x1;
    y:=dnb.y;
   if abs(x-dnb.x)<=dnb.r then begin
    if (y>=y1)and(y<=y2) then begin
     xl:=x; yl:=y; Touch_Line:=True end
    else
    if Distance(x1,y1,dnb.x,dnb.y)<=dnb.r then begin
     xl:=x1; yl:=y1; Touch_Line:=True end
    else
    if Distance(x2,y2,dnb.x,dnb.y)<=dnb.r then begin
     xl:=x2; yl:=y2; Touch_Line:=True end;
   end
  end
end;

function Touch_Dynamic_Body(dnb1,dnb2:dynamic_body) : boolean;
begin
  if Distance(dnb1.x,dnb1.y,dnb2.x,dnb2.y)<=(dnb1.r+dnb2.r) then
   Touch_Dynamic_Body:=True
  else
   Touch_Dynamic_Body:=False;
end;

function Touch_Curve(dnb:dynamic_body; stc:static_curve; var xc,yc:real) : boolean;
  var r,cos_a,sin_a,x,y : real;
      b,k,x1,y1,x2,y2   : real;
begin
   Touch_Curve:=False;
   b:=0;
   r:=Distance(dnb.x,dnb.y,stc.x,stc.y);
  if (r<(dnb.r+stc.rad))and(r>(-dnb.r+stc.rad)) then begin
   cos_a:=(dnb.x-stc.x)/r;
   sin_a:=(dnb.y-stc.y)/r;
   x:=cos_a*stc.rad+stc.x;
   y:=sin_a*stc.rad+stc.y;
   x1:=cos(stc.BegA*Pi/180)*stc.rad+stc.x;
   y1:=sin(stc.BegA*Pi/180)*stc.rad+stc.y;
   x2:=cos(stc.EndA*Pi/180)*stc.rad+stc.x;
   y2:=sin(stc.EndA*Pi/180)*stc.rad+stc.y;
  IF x1<>x2 THEN BEGIN
   k:=(y1-y2)/(x1-x2);
   b:=y1-k*x1;
  if (x1>x2)and(y>=k*x+b)or(x1<x2)and(y<=k*x+b) then begin
   xc:=x; yc:=y;
   Touch_Curve:=True
  end else
  if Distance(x1,y1,dnb.x,dnb.y)<=dnb.r then begin
   xc:=x1; yc:=y1;
   Touch_Curve:=True
  end else
  if Distance(x2,y2,dnb.x,dnb.y)<=dnb.r then begin
   xc:=x2; yc:=y2;
   Touch_Curve:=True
  end
  END ELSE
  if (y1<=y2)and(x>=x1)or(y1>=y2)and(x<=x1) then begin
   xc:=x; yc:=y;
   Touch_Curve:=True
  end else
  if Distance(x1,y1,dnb.x,dnb.y)<=dnb.r then begin
   xc:=x1; yc:=y1;
   Touch_Curve:=True
  end else
  if Distance(x2,y2,dnb.x,dnb.y)<=dnb.r then begin
   xc:=x2; yc:=y2;
   Touch_Curve:=True
  end
  end
end;

procedure Dynamic_Body_Hit(var dnb1,dnb2:dynamic_body);
  var cos_a,sin_a,r,dr : real;
      vx1,vx2,vy1,vy2  : real;
begin
   r:=Distance(dnb1.x,dnb1.y,dnb2.x,dnb2.y);
   dr:=dnb1.r+dnb2.r-r+0.001;
   cos_a:=(dnb1.x-dnb2.x)/r;
   sin_a:=(dnb1.y-dnb2.y)/r;
   vx1:=dnb1.speedx*cos_a+dnb1.speedy*sin_a;
   vx2:=dnb2.speedx*cos_a+dnb2.speedy*sin_a;
   vy1:=-dnb1.speedx*sin_a+dnb1.speedy*cos_a;
   vy2:=-dnb2.speedx*sin_a+dnb2.speedy*cos_a;
   dnb1.speedx:=2*(vx1*dnb1.m+vx2*dnb2.m)/(dnb1.m+dnb2.m)-vx1;
   dnb2.speedx:=2*(vx1*dnb1.m+vx2*dnb2.m)/(dnb1.m+dnb2.m)-vx2;
   vx1:=dnb1.speedx;
   vx2:=dnb2.speedx;
   dnb1.speedx:=vx1*cos_a-vy1*sin_a;
   dnb2.speedx:=vx2*cos_a-vy2*sin_a;
   dnb1.speedy:=vx1*sin_a+vy1*cos_a;
   dnb2.speedy:=vx2*sin_a+vy2*cos_a;
  if dr>0 then begin
   dnb2.x:=dnb2.x-0.5*dr*cos_a;
   dnb2.y:=dnb2.y-0.5*dr*sin_a;
   dnb1.x:=dnb1.x+0.5*dr*cos_a;
   dnb1.y:=dnb1.y+0.5*dr*sin_a;
  end
end;

procedure Static_Point_Hit(var dnb:dynamic_body; point_x,point_y:real; factor:real);
  var r,cos_a,sin_a,vx,vy,dr : real;
begin
   r:=Distance(dnb.x,dnb.y,point_x,point_y);
   cos_a:=(point_x-dnb.x)/r;
   sin_a:=(point_y-dnb.y)/r;
   vx:=dnb.speedx;
   vy:=dnb.speedy;
   dnb.speedx:=-factor*(vx*cos_a+sin_a*vy);
   dnb.speedy:=(-vx*sin_a+vy*cos_a);
   vx:=dnb.speedx;
   vy:=dnb.speedy;
   dnb.speedx:=(vx*cos_a-sin_a*vy);
   dnb.speedy:=vx*sin_a+vy*cos_a;
  if r<dnb.r then begin
   dr:=dnb.r-r+0.001;
   dnb.x:=dnb.x-dr*cos_a;
   dnb.y:=dnb.y-dr*sin_a;
  end
end;

procedure Check_Static_Hit(var dnb:dynamic_body; stlm:st_ln_mas; stcm:st_cr_mas);
  var x_line,y_line   : real;
      x_curve,y_curve : real;
      i               : integer;
begin
   i:=0;
   x_line:=0; y_line:=0;
   x_curve:=0; y_curve:=0;
  for i:=1 to n_st_b do
  if Touch_Line(dnb,stlm[i],x_line,y_line) then
   Static_Point_Hit(dnb,x_line,y_line,stlm[i].dE);
  for i:=1 to n_st_c do
  if Touch_Curve(dnb,stcm[i],x_curve,y_curve) then
   Static_Point_Hit(dnb,x_curve,y_curve,stcm[i].dE);
end;

procedure Check_Dynamic_Hit(var dnbm:dn_bd_mas; num:integer);
  var i   : integer;
begin
  for i:=num+1 to n_dn_b do
  if Touch_Dynamic_Body(dnbm[num],dnbm[i]) then
   Dynamic_Body_Hit(dnbm[num],dnbm[i]);
end;

procedure Control_Body(var dnb:dynamic_body; m:mouse_info);
  var i,r,vmax    : integer;
      sin_a,cos_a : real;
      dv    : real;
begin
  if m.l_b then begin
   vmax:=1; dv:=vmax/300;
   r:=round(Distance(dnb.x,dnb.y,m.x,m.y));
  if (r>0) then begin
   sin_a:=(m.y-dnb.y)/r;
   cos_a:=(m.x-dnb.x)/r;
  if r<300 then begin
   dnb.speedx:=dnb.speedx+r*dv*cos_a;
   dnb.speedy:=dnb.speedy+r*dv*sin_a;
  end else begin
   dnb.speedx:=dnb.speedx+vmax*cos_a;
   dnb.speedy:=dnb.speedy+vmax*sin_a;
  end
  end
  end
end;

procedure Check_Buttons(var dnb_num:integer; var exit:boolean);
  var c : char;
begin
  while KeyPressed do begin
   c:=ReadKey;
  if c in ['1','2','3','4','5','6','7','8','9'] then dnb_num:=ord(c)-48;
  if c=#27 then exit:=True;
  end;
  if (dnb_num<1)or(dnb_num>n_dn_b) then dnb_num:=1;
end;

procedure Trajectory_Calculation(var t:dn_bd_mas);
  var k,i : integer;
begin
   k:=100; i:=0;
  for i:=1 to n_dn_b do begin
   t[i].y:=t[i].y+(t[i].speedy*dt+t[i].ay*dt*dt/2)*k;
   t[i].x:=t[i].x+(t[i].speedx*dt+t[i].ax*dt*dt/2)*k;
   t[i].speedx:=t[i].speedx+t[i].ax*dt;
   t[i].speedy:=t[i].speedy+t[i].ay*dt;
  end;
  for i:=1 to n_dn_b do Check_Static_Hit(t[i],line_mas,curve_mas);
  for i:=1 to n_dn_b do Check_Dynamic_Hit(t,i);
end;

procedure Out_of_Range(var t:dn_bd_mas);
 var i,x_min,x_max,y_min,y_max,dx : integer;
begin
  dx:=(GetMaxX-50) div n_dn_b;
  x_min:=0; x_max:=GetMaxX;
  y_min:=0; y_max:=GetMaxY;
 for i:=1 to n_dn_b do
 if (t[i].x<x_min)or(t[i].x>x_max)or(t[i].y<y_min)or(t[i].y>y_max) then
  begin
   t[i].x:=dx*i;
   t[i].y:=100;
   t[i].speedx:=0;
   t[i].speedy:=0;
  end;
end;

Begin
Repeat
 repeat
   writeln('Choose any level ("1","2","3","4").');
   writeln('Enter "e" or "E" to exit.');
   readln(num);
 until (num in ['1','2','3','4'])or(num in ['e','E']);
 if not(num in ['e','E']) then begin
   exit:=false;
   Initgraph(gd,gm,'c:/tp/bgi');
   Error:=GraphResult;
 if Error <> grOk then writeln(GraphErrorMsg(Error)) else
  begin
   Preparation(dynamic_mas,line_mas,curve_mas,n_dn_b,n_st_b,n_st_c);
   Draw_Map;
   Delay(2000);
 repeat
   time:=0;
  for i:=1 to n_dn_b do begin
   dynamic_mas[i].xl:=dynamic_mas[i].x;
   dynamic_mas[i].yl:=dynamic_mas[i].y;
  end;
   Check_Mouse(mouse);
   Check_buttons(dn_body_num,exit);
   Control_Body(dynamic_mas[dn_body_num],mouse);
 repeat
   time:=time+dt;
   Trajectory_Calculation(dynamic_mas);
 until time>=Per;
   Out_of_Range(dynamic_mas);
  for i:=1 to n_dn_b do Draw_Dynamic_Body(dynamic_mas[i],true);
   Delay(round(Per*1000));
 until exit;
   CloseGraph;
  end
 end
Until (num in ['e','E']);
End.